;;;; run.scm


(use srfi-4 gl glut miscmacros matchable srfi-18)
(use 3viewer)


(define fade
  (let ((c 0)
	(n 0.001))
    (lambda ()
      (gl:ClearColor c c c 1)
      (inc! c n)
      (when (or (negative? c) (> c 0.5)) (set! n (- n)))
      #t)))

(add-effect fade)

(define a 0)

(define (spin id)
  (set! a (modulo (+ a 0.25) 360)))

(define (colorize id col)
  (gl:Materialfv 
   gl:FRONT_AND_BACK gl:AMBIENT_AND_DIFFUSE
   (if (object-highlighted? id)
       '#f32(1 1 0 1)
       col)))

(define (draw-cube id)
  (colorize id '#f32(1 0 0 1))
  (gl:Translatef -1.5 -1 0)
  (gl:Rotatef a 1 0 0)
  (gl:Rotatef a 0 1 0)
  (gl:Rotatef (- a) 0 0 1)
  (glut:SolidCube 1))

(define (draw-icos id)
  (colorize id '#f32(0 1 0 1))
  (gl:Translatef 1 0 0)
  (gl:Rotatef (* 2 a) 1 0 0)
  (gl:Rotatef a 0 1 0)
  (gl:Rotatef a 0 0 1)
  (glut:SolidIcosahedron))

(define (draw-tetra id)
  (colorize id '#f32(0 0 1 1))
  (gl:Translatef 0.5 2 -2)
  (gl:Rotatef (* 5 a) 0 1 0)
  (gl:Scalef 0.5 0.5 0.5)
  (glut:SolidTetrahedron))

(define (draw-sphere id)
  (colorize id '#f32(1 1 1 1))
  (gl:Translatef 0 0 -1)
  (glut:SolidSphere 0.25 20 20))

(add-object draw-cube animate: spin select: (lambda _ (print "oink!")))
(add-object draw-icos animate: spin)
(add-object draw-tetra animate: spin)
(add-object draw-sphere)

(define messages
  (circular-list "Om namah shivaya" "Ishq Allah" "Open my heart for thy beauty"))

(keymap-set! 
 (current-keymap) 
 '#\space (lambda _
	    (message (pop! messages))))

(current-table
 '(("one" . "two")
   #f
   ("eins" . "zwei")))

(match (command-line-arguments)
  (("3viewer" _)			; chicken-install -test
   (thread-start!
    (lambda ()
      (thread-sleep! 5)
      (exit))))
  (_ #f))

(start-viewer)
